#ifndef JUEGO_H_
#define JUEGO_H_

// Incluimos la cabecera principal de StdPijo
#include "StdPijo.h"

#include <iostream>

// Incluimos cabeceras para números aleatorios y retardos
#include <ctime>
#include <cstdlib>
#include <unistd.h>
#include "string.h"

using namespace std;

class Juego{
private:
	int nivelActual; //Variable que guarda el nivel en el que se encuentra la partida
	int puntuacionPartida; //Variable que guarda la puntuación en ese momento
	int incrementoMinas; //Variable que guarda el número de minas que se incrementa en cada nivel
	int incrementoTiempo; //Variable que guarda el número de bonus que incrementa en cada nivel
	int tiempoInicial; //Variable que guarda el bonus inicial de la partida
	int puntosPorAvance; //Variable que guarda los puntos por cada avance en el campo de minas
	int puntosPorMinas; //Variable que guarda los puntos por las minas evitadas en cada nivel
	int minasInicial; //Número de minas al iniciar la partida
	int bonusActual; //Bonus que hay en ese momento en la partida
	int minasActual; //Minas que hay en ese momento en la partida
	int modoSeleccionado; //Modo seleccionado (0 normal, 1 con objetos)
	int posicionPersonaje[2]; //Posición en coordenadas del personaje a controlar
	bool luz; //Variables que controlan los 5 objetos
	bool controles;
	bool paralisis;
	bool solucion;
	bool desorden;

public:
	Juego(){
		nivelActual=1;
		puntuacionPartida=0;
		incrementoMinas=5;
		incrementoTiempo=500;
		tiempoInicial=1000;
		puntosPorAvance=2;
		puntosPorMinas=5;
		minasInicial=15;
		bonusActual=tiempoInicial;
		minasActual=minasInicial;
		modoSeleccionado=0;
		luz = false;
		controles = false;
		paralisis = false;
		solucion = false;
		desorden = false;
	}

	void iniciarJuego(int modo); //Se inicia el juego
	void mostrarCuentaAtras(); //Muestra la cuentra atrás antes de empezar a jugar
	void mostrarDatosJuego(); //Muestra las minas y el nivel de la partida
	void restarBonus(); //Resta el bonus
	void mostrarBonus(); //Muestra el bonus por pantalla
	void mostrarPuntuacion(); //Muestra la puntuación por pantalla
	void mostrarTablero(); //Muestra el campo de minas
	bool controlPersonaje(int posicionMinas[][2],int posicionObjetos[15][3]); //Controla los diferentes sucesos del personaje con las minas y los objetos
	void generarMinas(int posicionMinas[][2],int posicionObjetos[15][3]); //Genera aleatoriamente minas para el campo de minas
	void mostrarMinas(int posicionMinas[][2]); //Muestra las minas en el campo de minas
	void generarObjetos(int posicionObjetos[15][3],int posicionMinas[][2]); //Genera aleatoriamente objetos para el campo de minas
	void mostrarObjetos(int posicionObjetos[15][3]); //Muestra los objetos en el campo de minas

	int pantallaFinNivel(); //Pantalla para seleccionar si seguir jugando o finalizar
	int getPuntuacion(){return puntuacionPartida;}
	int getNivel(){return nivelActual;}
};


#endif /* JUEGO_H_ */
